unit MainForm;
{
 TDriveView/TDirView/TIEComboBox Demo
 ====================================

(c) Ingo Eckel, 1999
    Sodener Weg 38
    65812 Bad Soden
    Germany


This is a simple demonstration program for the components of my filemanager toolset.

DriveDirViewDemo - Simple Explorer-like filemanager. It can detect inserted and removed CD-ROMs and
                   connecting/disconnecting network-drives at runtime (=> WM_DEVICECHANGE).

Components:
===========

TDriveView       - displays of directory structure as tree with shell icons.
TDirView         - displays all files of a directory as listview with shell icons. Complete
                   drag&drop support.
TIEDriveComboBox - Combobox displaying the available drives using shell icons.
TIEComboBox      - Slightly enhanced standard combobox.
}

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls,
  ToolWin, SysUtils, FileCtrl, ShellAPI, Messages,
  BaseUtils,
  ShellDialogs,
  DriveView,
  DirView,
  IEDriveInfo,
  IEComboBox;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    StatusBar: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileExitItem: TMenuItem;
    btnExit: TBitBtn;
    Refresh1: TMenuItem;
    btnRefresh: TSpeedButton;
    btnProperties: TSpeedButton;
    btnDelete: TSpeedButton;
    MnDisplay: TMenuItem;
    Delete1: TMenuItem;
    Properties1: TMenuItem;
    Directorysizes1: TMenuItem;
    N1: TMenuItem;
    Rename1: TMenuItem;
    Volumelabels1: TMenuItem;
    N2: TMenuItem;
    Filter1: TMenuItem;
    Search1: TMenuItem;
    btnSearch: TSpeedButton;
    N3: TMenuItem;
    IconThread: TMenuItem;
    ToolButton1: TToolButton;
    btnIcons: TSpeedButton;
    btnSmallIcons: TSpeedButton;
    btnList: TSpeedButton;
    btnReport: TSpeedButton;
    btnLink: TSpeedButton;
    ToolButton3: TToolButton;
    Columnicon: TMenuItem;
    HiddenGrey: TMenuItem;
    ChangeInterval: TMenuItem;
    N1Sec: TMenuItem;
    N2sec: TMenuItem;
    N3Sec: TMenuItem;
    Panel1: TPanel;
    DriveView1: TDriveView;
    Splitter1: TSplitter;
    DriveBox: TIEDriveComboBox;
    Network: TMenuItem;
    Connetcdrive1: TMenuItem;
    Disconnectdrive1: TMenuItem;
    Panel2: TPanel;
    DirView1: TDirView;
    DirComboBox: TIEComboBox;
    ShowDirs: TMenuItem;
    btnDirUp: TSpeedButton;
    Dateformat1: TMenuItem;
    DateTimeSec1: TMenuItem;
    DateTime1: TMenuItem;
    Date1: TMenuItem;
    Volumelabesstyle1: TMenuItem;
    Prettyname1: TMenuItem;
    Displayname1: TMenuItem;
    Undocopymove1: TMenuItem;
    Clearundo1: TMenuItem;
    CopytoClipboard1: TMenuItem;
    Cuttoclipboard1: TMenuItem;
    Pastefromclipboard1: TMenuItem;
    N4: TMenuItem;
    Confirm1: TMenuItem;
    Overwrite1: TMenuItem;
    Delete2: TMenuItem;
    DirViewPopup: TPopupMenu;
    Test: TMenuItem;
    Test21: TMenuItem;
    DriveViewPopup: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    Longprettyname1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Createshortcut1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure DirView1ChangeDetected(Sender: TObject);
    procedure DriveView1ChangeDetected(Sender: TObject; Drive : Char);
    procedure Refresh1Click(Sender: TObject);
    procedure DirView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure DirView1Loaded(Sender: TObject);
    procedure btnPropertiesClick(Sender: TObject);
    procedure DirView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DriveView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnDeleteClick(Sender: TObject);
    procedure DriveView1Change(Sender: TObject; Node: TTreeNode);
    procedure Directorysizes1Click(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure Volumelabels1Click(Sender: TObject);
    procedure Filter1Click(Sender: TObject);
    procedure Search1Click(Sender: TObject);
    procedure IconThreadClick(Sender: TObject);
    procedure btnIconsClick(Sender: TObject);
    procedure btnSmallIconsClick(Sender: TObject);
    procedure btnListClick(Sender: TObject);
    procedure btnReportClick(Sender: TObject);
    procedure btnLinkClick(Sender: TObject);
    procedure ColumniconClick(Sender: TObject);
    procedure HiddenGreyClick(Sender: TObject);
    procedure N2secClick(Sender: TObject);
    procedure N1SecClick(Sender: TObject);
    procedure N3SecClick(Sender: TObject);
    procedure Connetcdrive1Click(Sender: TObject);
    procedure Disconnectdrive1Click(Sender: TObject);
    procedure DirComboBoxChange(Sender: TObject);
    procedure ShowDirsClick(Sender: TObject);
    procedure btnDirUpClick(Sender: TObject);
    procedure DateTimeSec1Click(Sender: TObject);
    procedure DateTime1Click(Sender: TObject);
    procedure Date1Click(Sender: TObject);
    procedure Prettyname1Click(Sender: TObject);
    procedure Displayname1Click(Sender: TObject);
    procedure DriveView1DDError(Sender: TObject; ErrorNo: TDDError);
    procedure UndoFileCopyMoveExecute(Sender: TObject);
    procedure Clearundo1Click(Sender: TObject);
    procedure CopytoClipboard1Click(Sender: TObject);
    procedure Cuttoclipboard1Click(Sender: TObject);
    procedure Pastefromclipboard1Click(Sender: TObject);
    procedure Overwrite1Click(Sender: TObject);
    procedure Delete2Click(Sender: TObject);
    procedure DriveView1DDFileOperationExecuted(Sender: TObject;
      dwEffect: Integer; SourcePath, TargetPath: String);
    procedure DirView1DDFileOperationExecuted(Sender: TObject;
      dwEffect: Integer; SourcePath, TargetPath: String);
    procedure Longprettyname1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);

  private
    LastDD : TObject;

    {How to detect an inserted or removed CD-ROM or mounted network drives:
     The message WM_DEVICECHANGE is not passed to child-windows (Driveview1),
     so the media change can only be detected by the applications window:}
    procedure WMDeviceChange(Var Message : TMessage); message WM_DEVICECHANGE;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



procedure TForm1.FormCreate(Sender: TObject);
Var StartDir : String;
begin
  IF Not Assigned(DriveView1.Selected) Then
  Begin
    GetDir(0, StartDir);
    DriveView1.Directory := StartDir;
  End;

  IF Assigned(DriveView1.Selected) Then
  DriveView1.Selected.Expand(False);


  DirectorySizes1.Checked := DriveView1.ShowDirSize;
  VolumeLabels1.Checked   := DriveView1.ShowVolLabel;
  ColumnIcon.Checked      := DirView1.ShowColumnIcon;
  IconThread.Checked      := DirView1.UseIconUpdateThread;
  LastDD                  := NIL;
  IF Not HasExtendedCOMCTL32 Then
  Begin
    ColumnIcon.Enabled := False;
    ColumnIcon.Checked := False;
    HiddenGrey.Enabled := False;
    HiddenGrey.Checked := False;
  End;
end;

procedure TForm1.btnExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.DirView1ChangeDetected(Sender: TObject);
begin
  Statusbar.SimpleText := 'File change detected!';
end;

procedure TForm1.DriveView1ChangeDetected(Sender: TObject; Drive : Char);
begin
  Statusbar.SimpleText := 'Directory change detected on drive: ' + Drive;
end;

procedure TForm1.Refresh1Click(Sender: TObject);
begin
  With DriveView1 Do
  Begin
    ValidateDirectory(RootNode(Selected));
    RefreshRootNodes(False, dsDisplayName Or dsImageIndex Or dvdsFloppy or dvdsRereadAllways);
    IF ShowDirSize Then
    RefreshDriveDirSize(GetDrive(Selected));
  End;
  DirView1.Reload(True);
end;

procedure TForm1.DirView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  DirView1Loaded(Sender);
end;

procedure TForm1.DirView1Loaded(Sender: TObject);
begin
  With DirView1 Do
  StatusBar.SimpleText := Format('%u files = %s bytes / %u files selected = %s bytes', [Items.Count, FormatSize(FilesSize), SelCount, FormatSize(FilesSelSize)]);
end;


procedure TForm1.btnPropertiesClick(Sender: TObject);
begin
  IF DriveView1.Focused And Assigned(DriveView1.Selected) Then
  DriveView1.DisplayPropertiesMenu(DriveView1.Selected)
  Else
  IF DirView1.Focused And Assigned(DirView1.Selected) Then
  DirView1.DisplayPropertiesMenu
  Else
  Beep;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
begin
  IF DriveView1.Focused And Assigned(DriveView1.Selected) Then
  DriveView1.DeleteDirectory(DriveView1.Selected, True)
  Else
  IF DirView1.Focused And Assigned(DirView1.Selected) Then
  DirView1.DeleteSelectedFiles(True)
  Else
  Beep;
end;


procedure TForm1.DirView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  IF (Key = VK_DELETE) And Assigned(DirView1.Selected) And Not DirView1.isEditing Then
  DirView1.DeleteSelectedFiles(Not(ssShift in Shift));
end;


procedure TForm1.DriveView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  IF (Key = VK_DELETE) And Assigned(DriveView1.Selected) And Not DriveView1.isEditing Then
  DriveView1.DeleteDirectory(DriveView1.Selected, Not(ssShift in Shift));
end;

procedure TForm1.DirComboBoxChange(Sender: TObject);
begin
  DriveView1.Directory := DirComboBox.Items[DirComboBox.ItemIndex];
end;

procedure TForm1.DriveView1Change(Sender: TObject; Node: TTreeNode);
Var i : Integer;
begin
  i := DirComboBox.Items.IndexOf(DriveView1.Directory);
  IF i < 0 Then
  Begin
    DirComboBox.Items.Insert(0, DriveView1.Directory);
    i := 0;
  End;
  DirComboBox.ItemIndex := i;
end;


procedure TForm1.Directorysizes1Click(Sender: TObject);
begin
  DriveView1.ShowDirSize := Not DriveView1.ShowDirSize;
  DirectorySizes1.Checked := DriveView1.ShowDirSize;
end;


procedure TForm1.Volumelabels1Click(Sender: TObject);
begin
  VolumeLabels1.Checked := Not VolumeLabels1.Checked;
  DriveView1.ShowVolLabel := VolumeLabels1.Checked;
end;


procedure TForm1.IconThreadClick(Sender: TObject);
begin
  IconThread.Checked := Not IconThread.Checked;
  DirView1.UseIconUpdateThread := IconThread.Checked;
end;


procedure TForm1.ColumniconClick(Sender: TObject);
begin
  ColumnIcon.Checked := Not ColumnIcon.Checked;
  DirView1.ShowColumnIcon := ColumnIcon.Checked;
end;

procedure TForm1.ShowDirsClick(Sender: TObject);
begin
  ShowDirs.Checked := Not ShowDirs.Checked;
  DirView1.ShowDirectories := ShowDirs.Checked;
end;


procedure TForm1.HiddenGreyClick(Sender: TObject);
begin
  HiddenGrey.Checked := Not HiddenGrey.Checked;
  DirView1.DimmHiddenFiles  := HiddenGrey.Checked;
  DriveView1.DimmHiddenDirs := HiddenGrey.Checked;
end;

procedure TForm1.Overwrite1Click(Sender: TObject);
begin
  OverWrite1.Checked := Not OverWrite1.Checked;
  DriveView1.ConfirmOverwrite := OverWrite1.Checked;
  DirView1.ConfirmOverwrite   := OverWrite1.Checked;
end;


procedure TForm1.Delete2Click(Sender: TObject);
begin
  Delete2.Checked := Not Delete2.Checked;
  DriveView1.ConfirmDelete := Delete2.Checked;
  DirView1.ConfirmDelete   := Delete2.Checked;
end;


procedure TForm1.N1SecClick(Sender: TObject);
begin
  N1Sec.Checked := True;
  DirView1.ChangeInterval   := 1000;
  DriveView1.ChangeInterval := 1000;
end;

procedure TForm1.N2secClick(Sender: TObject);
begin
  N2Sec.Checked := True;
  DirView1.ChangeInterval   := 2000;
  DriveView1.ChangeInterval := 2000;
end;

procedure TForm1.N3SecClick(Sender: TObject);
begin
  N3Sec.Checked := True;
  DirView1.ChangeInterval   := 3000;
  DriveView1.ChangeInterval := 3000;
end;


procedure TForm1.Rename1Click(Sender: TObject);
begin
  IF DriveView1.Focused And Assigned(DriveView1.Selected) Then
  DriveView1.Selected.EditText
  Else
  IF DirView1.Focused And Assigned(DirView1.Selected) Then
  DirView1.Selected.EditCaption;
end;


procedure TForm1.Filter1Click(Sender: TObject);
Var NewFilter : String;
begin
  NewFilter := DirView1.Mask;
  IF InputQuery('File filter', 'Enter multiple file filter (separated by ; or space:', NewFilter) Then
  DirView1.Mask := NewFilter;
end;

procedure TForm1.btnIconsClick(Sender: TObject);
begin
  DirView1.ViewStyle := vsIcon;
  btnIcons.Down := True;
end;

procedure TForm1.btnSmallIconsClick(Sender: TObject);
begin
  DirView1.ViewStyle := vsSmallIcon;
  btnSmallIcons.Down := True;
end;

procedure TForm1.btnListClick(Sender: TObject);
begin
  DirView1.ViewStyle := vsList;
  btnList.Down := True;
end;

procedure TForm1.btnReportClick(Sender: TObject);
begin
  DirView1.ViewStyle := vsReport;
  btnReport.Down := True;
end;


procedure TForm1.WMDeviceChange(Var Message : TMessage);
const
  DBT_DEVICEARRIVAL	   = $8000;	// system detected a new device
  DBT_DEVICEREMOVECOMPLETE = $8004;     // device is gone

Begin
  Inherited;
  IF (Message.wParam = DBT_DEVICEARRIVAL) OR
     (Message.wParam = DBT_DEVICEREMOVECOMPLETE) Then
  Begin
    DriveView1.RefreshRootNodes(True, dsAll And Not dvdsFloppy Or dvdsRereadAllways);
    DriveBox.ResetItems;
  End;
End; {WMDeviceChange}


procedure TForm1.Search1Click(Sender: TObject);
begin
  IF Assigned(DriveView1.Selected) Then
    ShellExecute(Application.Handle, 'find', PChar(DriveView1.Directory), NIL, NIL, SW_SHOWNORMAL);
end;


procedure TForm1.btnLinkClick(Sender: TObject);
begin
  IF DirView1.Focused And Assigned(DirView1.ItemFocused) Then
  With DirView1 Do
    ShellExecuteContextCommand(Self.Handle, shcLink, GetFullFileName(ItemFocused));
end;


procedure TForm1.Connetcdrive1Click(Sender: TObject);
begin
  WNetConnectionDialog(Form1.Handle, RESOURCETYPE_DISK);
end;

procedure TForm1.Disconnectdrive1Click(Sender: TObject);
begin
  WNetDisconnectDialog(Form1.Handle, RESOURCETYPE_DISK);
end;


procedure TForm1.btnDirUpClick(Sender: TObject);
begin
  IF Assigned(DriveView1.Selected) And
     Assigned(DriveView1.Selected.Parent) Then
  DriveView1.Selected := DriveView1.Selected.Parent;
end;

procedure TForm1.DateTimeSec1Click(Sender: TObject);
begin
  DirView1.DateTimeDisplay := dtdDateTimeSec;
  DateTimeSec1.Checked := True;
end;

procedure TForm1.DateTime1Click(Sender: TObject);
begin
  DirView1.DateTimeDisplay := dtdDateTime;
  DateTime1.Checked := True;
end;

procedure TForm1.Date1Click(Sender: TObject);
begin
  DirView1.DateTimeDisplay := dtdDate;
  Date1.Checked := True;
end;

procedure TForm1.Prettyname1Click(Sender: TObject);
begin
  DriveView1.VolDisplayStyle := doPrettyName;
  DriveBox.DisplayStyle := doPrettyName;
  PrettyName1.Checked := True;
end;


procedure TForm1.Longprettyname1Click(Sender: TObject);
begin
  DriveView1.VolDisplayStyle := doLongPrettyName;
  DriveBox.DisplayStyle := doLongPrettyName;
  LongPrettyName1.Checked := True;
end;


procedure TForm1.Displayname1Click(Sender: TObject);
begin
  DriveView1.VolDisplayStyle := doDisplayName;
  DriveBox.DisplayStyle := doDisplayName;
  DisplayName1.Checked := True;
end;

procedure TForm1.DriveView1DDError(Sender: TObject; ErrorNo: TDDError);
begin
  MessageDlg(Format('drag/drop error %u occured.', [Ord(ErrorNo)]), mtError, [mbOK], 0);
end;

procedure TForm1.UndoFileCopyMoveExecute(Sender: TObject);
begin
  IF LastDD = DirView1 Then
  With DirView1 Do
  Begin
    IF CanUndoCopyMove Then
    UndoCopyMove;
  End
  Else If LastDD = DriveView1 Then
  With DriveView1 Do
  Begin
    IF CanUndoCopyMove Then
    UndoCopyMove;
  End;
end;

procedure TForm1.DriveView1DDFileOperationExecuted(Sender: TObject;
  dwEffect: Integer; SourcePath, TargetPath: String);
begin
  LastDD := DriveView1;
  UndoCopyMove1.Enabled := True;
  ClearUndo1.Enabled    := True;
end;


procedure TForm1.DirView1DDFileOperationExecuted(Sender: TObject;
  dwEffect: Integer; SourcePath, TargetPath: String);
begin
  LastDD := DirView1;
  UndoCopyMove1.Enabled := True;
  ClearUndo1.Enabled    := True;
end;


procedure TForm1.Clearundo1Click(Sender: TObject);
begin
  DirView1.DDFileOperator.ClearUndo;
  DriveView1.DDFileOperator.ClearUndo;
  LastDD := NIL;
  UndoCopyMove1.Enabled := False;
end;

procedure TForm1.CopytoClipboard1Click(Sender: TObject);
begin
  IF DriveView1.Focused Then
    DriveView1.CopyToClipBoard(DriveView1.Selected)
  Else
    DirView1.CopyToClipBoard;
end;

procedure TForm1.Cuttoclipboard1Click(Sender: TObject);
begin
  IF DriveView1.Focused Then
    DriveView1.CutToClipBoard(DriveView1.Selected)
  Else
    DirView1.CutToClipBoard;
end;

procedure TForm1.Pastefromclipboard1Click(Sender: TObject);
begin
  IF DriveView1.Focused Then
    DriveView1.PasteFromClipBoard
  Else
    DirView1.PasteFromClipBoard;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  MessageDlg('Filemanager Toolset Demo V2.3' + #10 + #10 +
             'Copyright Ingo Eckel 1999, All Rights Reserved' + #10 + #10 +
             'The latest version of this toolset can be found at my website:' + #10 +
             'http://home.t-online.de/home/ingo.eckel/',
             mtInformation, [mbOK], 0);
end;

end.
